/*
 * Copyright (c) 2001-2003 Shiman Associates Inc. All Rights Reserved.
 * 
 * Permission is hereby granted, free of charge, to any person
 * obtaining a copy of this software and associated documentation
 * files (the "Software"), to deal in the Software without
 * restriction, including without limitation the rights to use, copy,
 * modify, merge, publish, distribute, sublicense, and/or sell copies
 * of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
 * BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 *
 */

/* $Id: aixppc.h,v 1.3 2004/04/30 23:46:40 silvio Exp $ */
#ifndef _ANX_AIX_H
#define _ANX_AIX_H

#include <sys/audio.h>

/* kinda sketchy... define this thing to make it look like a channel
   from sys/audio.h. Make sure this value doesn't exist in that file! */
#define MASTER_VOLUME_CHANNEL   99

#define DEFAULT_PLAY_CHANNEL    AUDIO_OUTPUT_1
#define DEFAULT_REC_SOURCE      AUDIO_HIGH_GAIN_MIKE
#define DEFAULT_PLAY_BLOCK_SIZE 128
#define DEFAULT_AUDIO_DEVICE    "/dev/paud0"

#define DEFAULT_RES_STATE_ITO_S 10
#define DEFAULT_RES_STATE 2
/*
 * Choosing DEFAULT_BUFTIME_US:
 * 1. Don't make it too large because it gets written all at once to
 *    the soundcard.
 * 2. Taking into account the sample size and channels, this time-size
 *    has to be smaller than PLAY_BUFFER_SIZE.
 * 
 */
#define DEFAULT_BUFTIME_MS      50

#define PLAY_BUFFER_SIZE        176400

/* this is the recording segment length... need to make adjustable */
/* it MUST be an integer multiple of BPSTC */

#define MAS_ANX_SEGLEN 2048      

#define MAX_FRAGSIZE_MS         50 /* give up after this - we probably
                                      can't set the fragment size */ 
#define MIN_FRAGSIZE_US         800 /* minimum fragment size in
                                        microseconds */
#define ALLOCATED_MIX_CH        AUDIO_MAX_TABLE_SIZE


/* /\* these DMA-related parameters aren't used yet. *\/ */
/* #define TARGET_DMABUF_TIME_MS   1000 */
/* #define MIN_DMABUF_TIME_MS      50 */


struct aix_state
{
    char           devfname[128];
    int            play_fd;
    int            rec_fd;
    u_int16        fragsize;
    u_int16        fragments;

    int            is_fragment_accurate;
    int            is_mmap_able;

    /* mixer */
    int mix_fd;
    int mstvol_fd;
    int aix_mch_map[ALLOCATED_MIX_CH];
    
    /* is device open and configured? */
    int play_configured;
    int rec_configured;
    
    int rec_source; /* aix channel used for recording */

    int8 internal_speaker_state;
};

#endif /* _ANX_AIX_H */
